#ifndef COOBJ_H
#define COOBJ_H

#include <windows.h>

class CoObject
{
public:
    virtual void * AcquireInterface (IID const & iid) = 0;
};

class SObject: public CoObject
{
public:
    SObject (CLSID const & classId);
    ~SObject ()
    {
        if (_iUnk)
            _iUnk->Release ();
    }
    void * AcquireInterface (IID const & iid);

private:
    IUnknown * _iUnk;
};

#endif